#include <pic.h>				// pic specific identifiers
#define _XTAL_FREQ  4000000		// Xtal speed
__CONFIG(0x3D18);				// Config bits

#define IR_PORT		PORTB			//
#define IR_TRIS		TRISB
#define IR_in		RB2
#define IR_out		RB1

#define SW1			RA0
#define SW2			RA1
#define SW3			RA2
#define SW4			RA3

#define OUT_PORT	PORTB
#define LED			RB7

#define	ErrFlag		0x0
#define	StartFlag	0x1
#define	One			0x2
#define	Zero		0x4

#define	New			0x7
#define	TV			0x1

#define	But1		0x0
#define	But2		0x1
#define	But3		0x2
#define	But4		0x3
#define	But5		0x4
#define	But6		0x5
#define	But7		0x6
#define	But8		0x7
#define	But9		0x8
#define	VolUp		18
#define	VolDown		19
#define	ProgUp		16
#define	ProgDown	17

		// Required prototypes

int getkey(void);
void delayMs(int x);
void sendIr(char cmd, char device), makepulse(int pluse), nopulse(int pluse);


// variables

unsigned char Bit_Cntr, Cmd_Byte=0, Dev_Byte=0;
unsigned char Timer_H, Flags=0, Flags2, lastdev, lastkey;


void main(void)							// program entry
	{
	int key ;							// keypad variable

	OPTION = 0x88;						// timer pre-scaler
	CMCON = 0x7;						// Comparitors off
	TRISA = 0b11111;					// Led port as outputs
	IR_TRIS = 0b11111101;				// IR port
	__delay_ms(150);					// settle

	while(1)							// endless Loop
		{
		key = getkey();
		if(key==1) sendIr(ProgUp,TV);
		if(key==2) sendIr(ProgDown,TV);
		if(key==3) sendIr(VolUp,TV);
		if(key==4) sendIr(VolDown,TV);
		}
	}

int getkey()
	{
	char key = 0;
	if(!SW1) key = 1;
	if(!SW2) key = 2;
	if(!SW3) key = 3;
	if(!SW4) key = 4;
	if(key)
		{
		__delay_ms(150);
		}
	return key;
	}

void sendIr(char cmd, char device)
	{
	char x;
	makepulse(92);
	nopulse(23);
	for(x = 0; x<7;x++)
		{
		if(cmd & 1)
			{
			makepulse(46);
			nopulse(23);
			}
		else
			{
			makepulse(23);
			nopulse(23);
			}
		cmd >>= 1;
		}
	for(x = 0; x<5;x++)
		{
		if(device & 1)
			{
			makepulse(46);
			nopulse(23);
			}
		else
			{
			makepulse(23);
			nopulse(23);
			}
		device >>= 1;
		}
	}


void makepulse(int pulse)
	{
	while(pulse--)
		{
		IR_out = 1;
		__delay_us(2);
		IR_out = 0;
		__delay_us(1);
		}

	}

void nopulse(int pulse)
	{
	while(pulse--)
		{
		IR_out = 0;
		__delay_us(2);
		IR_out = 0;
		__delay_us(1);
		}

	}


void delayMs(int x)
	{
	while(x--) __delay_ms(1);
	}

